
function DriveImages(id)
{
 this.ID = "driveimages_" + id;
 
 this.tblList = new DriveImagesDataTable();
 this.tblList.Width = "100%";
 this.tblList.Cellspacing = "0";
 this.tblList.Cellpadding = "3";
 this.tblList.ID = "tblList_driveimages_" + id;
 
 this.tblList.ItemClass = "devicelistEven";
 this.tblList.AlternateItemClass = "devicellistOdd";
 
 this.MountEvent = "external.MountImage";
 
 this.Add = _AddDriveImages;
 this.Delete = __DeleteDriveImages;
 this.Render = _RenderDriveImages;
 
 this.Modify = _ModifyDriveImage;
}

function _RenderDriveImages()
{
 return this.tblList.Render();
}

function _AddDriveImages( id,driveimagename , IsMount )
{
var rowID = "tr_" + this.tblList.ID + "_" + id;

if(Get(rowID) != null )
 return; // already exists  a row with the given id

  
  var view = new ActionButton();
  view.ID = this.ID + "_"+id;
  
  view.Type = ACTION_BUTTON_LINK;
  
  if( IsMount == true )
    view.Text = "Unmount";
  else
    view.Text = "Mount";
     
 // view.Event = this.ViewEvent + "('" +drive+ "');";
  view.Event =  this.MountEvent +"('"+id +"',"+!IsMount+ ");";
 
  this.tblList.AddWithKey(id, driveimagename,  view.Render() );
}


function __DeleteDriveImages( id )
{
  this.tblList.DeleteRow( id );
}

function _ModifyDriveImage( id, name, IsMount )
{
 var view = new ActionButton();
  view.ID = this.ID + "_"+id;
   view.Type = ACTION_BUTTON_LINK;
  
  if( IsMount == true )
    view.Text = "Unmount";
  else
    view.Text = "Mount";
     
  view.Event =  this.MountEvent +"('"+id +"',"+!IsMount+ ");";
 
  var rowID = "tr_" + this.tblList.ID + "_" + id;
  
  if ( Get( rowID ) == null )
   return; // row not found
  
  var rowIndex = Get( rowID ).rowIndex;
  
  // change mount text
  this.tblList.ChangeCell( view.Render(), rowIndex, 1 );
  
  // change driveimage name
  this.tblList.ChangeCell( name, rowIndex, 0 );
   
}


//this class uses 'datatable.js' functions 
//
function DriveImagesDataTable()
{

this.ID = "";
  this.Class = "";
  this.Style = "";
  this.Width = "";
  this.LabelClass = "NOT_ASSIGNED";
  this.ValueClass = "NOT_ASSIGNED";
  
  this.ItemClass = "NOT_ASSIGNED";
  this.AlternateItemClass = "NOT_ASSIGNED";
  
  this.Border = "0";
  this.Cellspacing = "1";
  this.Cellpadding = "3";
  
  this.Items = new Array();
  this.Render = __RenderDriveImagesDataTable;
//  this.Add = __AddItemToDataTable;
  this.AddWithKey = __AddItemToDriveImagesDataTableWithKey;
  this.ChangeCell = __ChangeDataTableCell;
  
  this.DeleteRow = __DeleteRow;
  this.DeleteRowByIndex = __DeleteRowByIndex;
  this.Alternate = __Alternate;
  
  this._Rendered = false;
  
  this._ClientID = __ClientID;
}


function DriveImagesDataTableItem()
{
  this.Items; // array of values
  
  // id of the parent table
  this.ParentID = "";  
  
  this.PrimaryKey = true;
  
  this.Label;
  this.Value;
  
  this.ItemClass = "NOT_ASSIGNED";
  this.AlternateItemClass = "NOT_ASSIGNED";
  
  this.Render = __RenderDriveImagesDataTableItem;
}


function __RenderDriveImagesDataTableItem()
{
  var content = "";
  
  var id = "";
  var start = 0;
  
  if ( this.Items[0] != "" && this.Items[0] != null && this.PrimaryKey)
  {
    id = "id=\"tr_" + this.ParentID + "_" + this.Items[0] + "\"";  
    start = 1;
  }
  
  if ( arguments.length )
  {
			var x = arguments[0];
			if(x % 2 == 0)
     {
       content += "<tr valign=\"top\"  "+ id  +" class=\""+ this.ItemClass +"\">";
     }
     else
     {
       content += "<tr valign=\"top\"  "+ id  +" class=\""+ this.AlternateItemClass +"\">";
     }   
	}
	else
	{
   content += "<tr valign=\"top\"  "+ id  +" >";
  }
  
  content += "<td >";
    content += this.Items[1];
    content += "</td>";
    
    content += "<td align='right'>";
    content += this.Items[2];
    content += "</td>";
 
  content += "</tr>";
  
  return content;
}


function __RenderDriveImagesDataTable()
{
  var content = "";
  content += "<table id=\"datatable_tbl_" + this.ID + "\"cellspacing=\"" + this.Cellspacing + "\" cellpadding=\"" + this.Cellpadding + "\" border=\"" + this.Border + "\"";
  
  if (this.Width != "")
    content += " width=\"" + this.Width + "\"";
  
  content += ">";
  
  for (var x = 0; x < this.Items.length; x++)
  {
    content += this.Items[x].Render(x);
  }
  
  content += "</table>";
  
  this._Rendered = true;  
  
  
  return content;
}



// Adding a new row to the table 
// Example : suppose columns = 3, "__AddItemToDataTable(pk, v1, v2, v3)" 
// the first value is taken as the primarykey and will not add to the row
function __AddItemToDriveImagesDataTableWithKey()
{
  var item = new DriveImagesDataTableItem();
  item.ParentID = this.ID;
  
  item.PrimaryKey = true;
  
   // values array
  item.Items = arguments;
  
  //item.Label = label;
  //item.Value = value;
  item.LabelClass = this.LabelClass;
  item.ValueClass = this.ValueClass;
  
  item.ItemClass = this.ItemClass;
  item.AlternateItemClass = this.AlternateItemClass;

  if (this._Rendered)
  {
    // The data table has already been rendered, so we need to manually 
    // add the data table item.
    var tbl = Get("datatable_tbl_" + this.ID);
    
    if ( tbl == null )
      return;
      
    var tbody = tbl.childNodes[0];
    var row = tbody.insertRow(tbody.rows.length);
   
    if ( item.Items[0] != "" && item.Items[0] != null)
    {
      // adding the primary key to the table row 'id' 
      var rowid = "tr_" + this.ID + "_" + item.Items[0];  
       row.setAttribute('id', rowid );
    }
    
    var cell = null;
    
    cell = row.insertCell(row.cells.length);
     cell.innerHTML = item.Items[1];
     
     cell = row.insertCell(row.cells.length);
     cell.innerHTML = item.Items[2];
     cell.setAttribute('align','right');
  }

  this.Items[this.Items.length] = item;
  
  // recalculate row background colors
  this.Alternate();
  
}