var ANIMATE_EXPAND_TIMEOUT = 5;


function Animate_GetDelta(currentHeight, totalHeight)
{
  var delta = 0;
  var percentage = Math.round((currentHeight / totalHeight) * 100);;

  if (percentage > 75)
  {
    //delta = 3;
    delta = Math.round(totalHeight * 0.03);
    
    if (delta < 1)
      delta = 1;
  }
  else if (percentage > 50)
  {
    //delta = 10;
    delta = Math.round(totalHeight * 0.07);
  }
  else if (percentage > 25)
  {
    //delta = 20;
    delta = Math.round(totalHeight * 0.10);
  }
  else
  {
    //delta = 30;
    delta = Math.round(totalHeight * 0.20);
  }

  return delta;  
}

function Animate_Continue(currentHeight, totalHeight)
{
  if (currentHeight < totalHeight)
    return true;
  else
    return false;
}


// This function begins the animation of the panel element by setting the height
// to 1 pixel and setting the other animation properties. The return value is the
// starting height of the panel to be used by the display element's internal
// height tracking mechanism.
function Animate_BeginAnimation(panelId)
{
  var panel = document.getElementById(panelId);
  
  Animate_SetPanelHeight(panelId, 1);

  panel.style.overflow = "hidden";
  panel.style.display = "block";
  
  return 1;
}

// This function ends the animation of the panel element by setting the overflow
// of the panel to visible to ensure the panel makes it to it's correct height. The
// return value of this function is the current height of the panel.
function Animate_EndAnimation(panelId)
{
  var panel = document.getElementById(panelId);
  
  panel.style.overflow = "visible";
  return panel.offsetHeight;
}

function Animate_SetPanelHeight(panelId, height)
{
  var panel = document.getElementById(panelId);
  panel.style.height = height + "px";
}

function Get(id)
{
  return document.getElementById(id);
}

function SetClass(id, className)
{
  var element = document.getElementById(id);
  element.className = className;
}

function SetDisplay(id, display)
{
  var element = document.getElementById(id);
  element.style.display = display;
}

function ToggleDisplay(id)
{
  var element = document.getElementById(id);
  
  if (element.style.display == "none")
    element.style.display = "block";
  else
    element.style.display = "none";
}

// id : id of the control
// value : boolean (true/ false )
function SetDisplay( id , value )
{
  if ( value )
  {
   Get(id).style.display = "inline"
  }
  else
  {
   Get(id).style.display = "none"
  }
  
}
// id : id of the control
// value : boolean (true/ false )
function SetDisplayBlock( id , value )
{
  if ( value )
  {
   Get(id).style.display = "block"
  }
  else
  {
   Get(id).style.display = "none"
  }
  
}


function ToggleWidget(divid , imgid)
{
  var imgmax = "maximize.gif";
  var imgmin = "minimize.gif";
  
  var img = document.getElementById(imgid);
 
  var element = document.getElementById(divid);
  
  if (element.style.display == "none")
  {
    element.style.display = "block";
    img.src = imgmin;
  }
  else
  {
    element.style.display = "none";
    img.src = imgmax;
  }
}
//function GrowPanel()
//{

/*
function __ToggleProblemWidgetPanelGrow(widgets, index)
{
  var delta = 0;
  var percentage = 0;

  widgets[index]._SetPanelHeight(widgets[index].CurrentChildHeight);
  percentage = Math.round((widgets[index].CurrentChildHeight / widgets[index].ChildHeight) * 100);

  if (percentage > 75)
  {
    delta = 3;
  }
  else if (percentage > 50)
  {
    delta = 10;
  }
  else if (percentage > 25)
  {
    delta = 20;
  }
  else
  {
    delta = 30;
  }
  
  widgets[index].CurrentChildHeight += delta;


  if (widgets[index].CurrentChildHeight < widgets[index].ChildHeight)
  {
    window.setTimeout("__ToggleProblemWidgetPanelGrow(" + widgets[index].ArrayName + "," + widgets[index].ArrayIndex + ")", 5);
  }
  else
  {
    // Get a handle to the widget child panel and make the overflow auto
    var element = document.getElementById("problemwidget_" + widgets[index].ID + "_child");
    element.style.overflow = "visible";
    
    element = document.getElementById("problemwidget_" + widgets[index].ID + "_childbody");
    widgets[index].ChildHeight = element.offsetHeight;
    
    widgets[index]._SetPanelHeight(widgets[index].ChildHeight);
  }
}

*/

function URLEncode(text )
{
	// The Javascript escape and unescape functions do not correspond
	// with what browsers actually do...
	var SAFECHARS = "0123456789" +					// Numeric
					"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +	// Alphabetic
					"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()";					// RFC2396 Mark characters
	var HEX = "0123456789ABCDEF";

	var plaintext = text;
	var encoded = "";
	for (var i = 0; i < plaintext.length; i++ ) {
		var ch = plaintext.charAt(i);
	    if (ch == " ") {
		    encoded += "+";				// x-www-urlencoded, rather than %20
		} else if (SAFECHARS.indexOf(ch) != -1) {
		    encoded += ch;
		} else {
		    var charCode = ch.charCodeAt(0);
			if (charCode > 255) {
			    alert( "Unicode Character '" 
                        + ch 
                        + "' cannot be encoded using standard URL encoding.\n" +
				          "(URL encoding only supports 8-bit characters.)\n" +
						  "A space (+) will be substituted." );
				encoded += "+";
			} else {
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	} // for

return encoded;
//	document.URLForm.F2.value = encoded;
//	return false;
}

function URLDecode( text )
{
   // Replace + with ' '
   // Replace %xx with equivalent character
   // Put [ERROR] in output if %xx is invalid.
   var HEXCHARS = "0123456789ABCDEFabcdef"; 
   //var encoded = document.URLForm.F2.value;
   var encoded = text;
   var plaintext = "";
   var i = 0;
   while (i < encoded.length) {
       var ch = encoded.charAt(i);
	   if (ch == "+") {
	       plaintext += " ";
		   i++;
	   } else if (ch == "%") {
			if (i < (encoded.length-2) 
					&& HEXCHARS.indexOf(encoded.charAt(i+1)) != -1 
					&& HEXCHARS.indexOf(encoded.charAt(i+2)) != -1 ) {
				plaintext += unescape( encoded.substr(i,3) );
				i += 3;
			} else {
				alert( 'Bad escape combination near ...' + encoded.substr(i) );
				plaintext += "%[ERROR]";
				i++;
			}
		} else {
		   plaintext += ch;
		   i++;
		}
	} // while
	
	return plaintext;
//   document.URLForm.F1.value = plaintext;
//   return false;
};